#DEFINE INCLU_BACK(_P_) "' " & RIGHT(STR(_P_ + 1000), 3) & " back from "
#DEFINE FILE_START(_P_) "' " & RIGHT(STR(_P_ + 1000), 3) & " start from: "
#DEFINE EXTE_COMM " ' (" & PROG_NAME & " -P_oCD option)"
#DEFINE LANG_COMM " ' (" & PROG_NAME & " -P_oBV option)"

TYPE BiWriter
  AS STRING TyNa = STACK_NEW
  AS STRING SuFu = STACK_NEW
  AS STRING Fok = STACK_NEW
  AS STRING Fko = STACK_NEW
  AS STRING LaWo
  AS CFileReader PTR In
  AS INTEGER Deep
  DECLARE DESTRUCTOR()
  DECLARE CONSTRUCTOR(BYREF F AS STRING, _
                      BYVAL O AS Config PTR, _
                      BYVAL P AS Options PTR, _
                      BYVAL M AS Macros PTR, _
                      BYVAL I AS CFileReader PTR, _
                      BYVAL E AS ErrorHandler PTR)
  DECLARE SUB add(BYREF T AS STRING, BYVAL Fl AS INTEGER = 0)
Private:
  AS STRING BiNa, JoNa, CoLi
  AS INTEGER Fnr, Count
  AS DOUBLE Ti
  AS ErrorHandler PTR Er
  AS Options PTR Op
  AS Macros PTR Ma
  AS Config PTR Co

  DECLARE SUB writePostReps(BYREF T AS STRING)
  DECLARE FUNCTION ZeileProtNr(BYREF T AS STRING, BYREF N AS STRING) AS STRING
  DECLARE SUB writeRep(BYREF T AS STRING, BYVAL R AS RepData PTR, _
                       BYVAL N AS INTEGER, BYVAL Mo AS INTEGER)
  DECLARE SUB writeSta(BYREF T AS STRING, BYREF R AS STRING, BYVAL Mo AS INTEGER)
  DECLARE SUB writeMac(BYVAL Mo AS INTEGER)
  DECLARE STATIC FUNCTION NormRep(BYREF S AS ZSTRING PTR, _
                                  BYREF E AS ZSTRING PTR, _
                                  BYREF Az AS INTEGER, _
                                  BYVAL Po AS ANY PTR) AS INTEGER
  DECLARE STATIC FUNCTION MacrRep(BYREF S AS ZSTRING PTR, _
                                  BYREF E AS ZSTRING PTR, _
                                  BYREF Az AS INTEGER, _
                                  BYVAL Po AS ANY PTR) AS INTEGER
END TYPE

CONSTRUCTOR BiWriter(BYREF F AS STRING, _
                     BYVAL C AS Config PTR, _
                     BYVAL P AS Options PTR, _
                     BYVAL M AS Macros PTR, _
                     BYVAL I AS CFileReader PTR, _
                     BYVAL E AS ErrorHandler PTR)
  Co = C
  Op = P
  Ma = M
  In = I
  Er = E
  JoNa = F
  BiNa = F & BI_FILE_SUFFIX
  Fnr = FREEFILE
  IF Op->RunMod = 1 THEN
    IF OPEN CONS (FOR OUTPUT, AS #Fnr) THEN Deep = -1 : EXIT CONSTRUCTOR
  ELSE
    VAR Na = F & "_Test.bas"
    IF NOT FILEEXISTS(Na) THEN
      IF OPEN (Na FOR OUTPUT AS #Fnr) THEN
        ?" Unable to write: " & Na
      ELSE
        PRINT #Fnr, "#INCLUDE """ & BiNa & """"
        CLOSE #Fnr
      END IF
    END IF : Ti = TIMER
    IF OPEN (BiNa FOR OUTPUT AS #Fnr) THEN
      ?" Unable to write: " & BiNa : Deep = -1 : EXIT CONSTRUCTOR
    END IF
  END IF
  IF LEN(Co->Start) THEN add(Co->Start & NL)
  IF Op->O.CD = 0 THEN
    add("#LANG ""fb""" & NL & "EXTERN ""C""" & EXTE_COMM)
  ELSEIF Op->O.BV = 0 THEN
    IF Op->O.CD THEN add("#LANG ""fb""" & LANG_COMM)
  END IF
END CONSTRUCTOR

' writes translation result into output file, does BAREP.rep replacements
' schreibt das Ergebnis der Wandlung in Datei, ggf. Replace
DESTRUCTOR BiWriter()
  IF Op->O.CD = 0 THEN PRINT #Fnr, NL & NL & "END EXTERN" & EXTE_COMM;
  IF Op->RunMod = 1 THEN
    IF LEN(Co->Ende) THEN PRINT #Fnr, NL & Co->Ende;
    PRINT #Fnr, : CLOSE #Fnr : EXIT DESTRUCTOR
  END IF
  ? "       directory: "; CURDIR
  ? "     output file: "; BiNa
  ? "      Parameters: ";
  IF LEN(Co->CoLi) THEN ? Co->CoLi ELSE ? "none (default)"

  IF LEN(Co->Ende) THEN
    PRINT #Fnr, NL & FILE_START(0) & JoNa & H2BI_FILE_SUFFIX & ", section " & KEY_END;
    PRINT #Fnr, NL & NL & Co->Ende;
  END IF

  VAR az = LOF(Fnr) - LEN(Co->Start)
  PRINT #Fnr, NL & NL & "' Translated at " & FORMAT(NOW, "yy-mm-dd hh:mm:ss") & _
              ", by " & PROG_NAME & " (version " & PROG_VERS & "," & NL & _
              "' released under GPLv3 by Thomas[ dot ]Freiherr[ at ]gmx[ dot ]net)"

  IF Op->FLP = 0 THEN CLOSE #Fnr : EXIT DESTRUCTOR
  IF Op->P.NA THEN PRINT #Fnr, NL & "'   Protocol: "; BiNa
  IF Op->P.PA THEN PRINT #Fnr, "' Parameters: "; COMMAND & CoLi
  IF Op->P.TI THEN PRINT #Fnr, ZeileProtNr("Process time [s]", STR(TIMER - Ti))
  IF Op->P.BY THEN PRINT #Fnr, ZeileProtNr("Bytes translated", STR(az))
  IF Op->P.DE THEN PRINT #Fnr, ZeileProtNr("Maximum deep", STR(Deep))
  writeSta("SUB/FUNCTION names",     SuFu, Op->P.NS + 2 * Op->P.LS)
  writeSta("mangled TYPE names",     TyNa, Op->P.NX + 2 * Op->P.LX)
  writeSta(        "files done",     Fok , Op->P.NF + 2 * Op->P.LF)
  writeSta(      "files missed",     Fko , Op->P.NY + 2 * Op->P.LY)
  writeSta(         KEY_FOLDERS, Co->Fold, Op->P.ND + 2 * Op->P.LD)
  writeMac(Op->P.NM + 2 * Op->P.LM)
  writeRep(KEY_HEADERS,   @Co->Head,      Co->AzHe, Op->P.NH + 2 * Op->P.LH)
  writeRep(KEY_TYPES,     @Co->Typ_, -Co->AzTy + 1, Op->P.NT + 2 * Op->P.LT)
  writeRep(KEY_POST_REPS, @CO->Post, CO->Post.Az(), Op->P.NP + 2 * Op->P.LP)
  CLOSE #Fnr
END DESTRUCTOR

' generates a comment line with tab on screen and in .bi
' erzeugt eine Kommentarzeile mit Tabulator (fuer console und .bi-Datei)
FUNCTION BiWriter.ZeileProtNr(BYREF T AS STRING, BYREF N AS STRING) AS STRING
  VAR p = 50 - LEN(T) : IF p < 1 THEN p = 1
  VAR r = STRING(p, 32) & T & ": " & N : ? r : RETURN "'" & r
END FUNCTION

' callback, generating a line for REP in output file
' Rueckruf-Funktion generiert eine REP-Zeile in Ergebnisdatei
STATIC FUNCTION BiWriter.MacrRep(BYREF Su AS ZSTRING PTR, _
                                 BYREF Er AS ZSTRING PTR, _
                                 BYREF Az AS INTEGER, _
                                 BYVAL Po AS ANY PTR) AS INTEGER
  VAR b = CAST(BiWriter PTR, Po), e = INSTR(b->Count, b->Co->Macros, CHR(1))
  PRINT #b->Fnr, genKom(Az & ": " & MID(b->Co->Macros, b->Count, e - b->Count))
  b->Count = e + 1 :  RETURN 0
END FUNCTION

' writes REP-definitions as comment to output file
' schreibt REP-Definitionen als Kommentar in die Ausgabedatei
SUB BiWriter.writeMac(BYVAL Mo AS INTEGER)
  Count = 6
  IF BIT(Mo, 0) THEN PRINT #Fnr, ZeileProtNr(KEY_MACROS, STR(Ma->Def.az()))
  IF BIT(Mo, 1) THEN Ma->Def.list(@BiWriter.MacrRep, @THIS)
END SUB

' callback, generating a line for REP in output file
' Rueckruf-Funktion generiert eine REP-Zeile in Ergebnisdatei
STATIC FUNCTION BiWriter.NormRep(BYREF Se AS ZSTRING PTR, _
                                 BYREF Re AS ZSTRING PTR, _
                                 BYREF Az AS INTEGER, _
                                 BYVAL Po AS ANY PTR) AS INTEGER
  VAR t = ">", p = 0, bw = CAST(BiWriter PTR, Po)
  IF bw->Count < 0 THEN bw->Count = ABS(bw->Count) : RETURN 0
  bw->Count -= 1 : IF bw->Count < 0 THEN RETURN 1
  WHILE (*Se)[p] = (*Re)[p] '                            compare strings
    p += 1
    IF (*Se)[p] = 0 THEN
      t = "&" : Re += p + IIF(*(Re + p) = TYKENN, LEN(TYKENN), 0) : EXIT WHILE
    END IF : IF (*Re)[p] = 0 THEN EXIT WHILE
  WEND : PRINT #bw->Fnr, "'" & Az & ": " & *Se & t & *Re : RETURN 0
END FUNCTION

' writes REP-definitions as comment to output file
' schreibt REP-Definitionen als Kommentar in die Ausgabedatei
SUB BiWriter.writeRep(BYREF T AS STRING, BYVAL R AS RepData PTR, _
                      BYVAL N AS INTEGER, BYVAL Mo AS INTEGER)
  IF BIT(Mo, 0) THEN PRINT #Fnr, ZeileProtNr(T, STR(ABS(N)))
  IF BIT(Mo, 1) THEN Count = N : R->list(@BiWriter.NormRep, @THIS)
END SUB

' writes STACK-definitions as comment to output file
' schreibt STACK-Definitionen als Kommentar in die Ausgabedatei
SUB BiWriter.writeSta(BYREF T AS STRING, BYREF R AS STRING, BYVAL Mo AS INTEGER)
  IF BIT(Mo, 0) THEN PRINT #Fnr, ZeileProtNr(T, STR(CVI(LEFT(R, 4))))
  IF BIT(Mo, 1) = 0 THEN EXIT SUB
  VAR a = 6, e = INSTR(a, R, CHR(1))
  WHILE e > a
    PRINT #Fnr, "' " & MID(R, a, e - a)
    a = e + 1 : e = INSTR(a, R, CHR(1))
  WEND
END SUB

' replaces words in basic source
' ersetzt Woerter im Basic Quelltext
SUB BiWriter.writePostReps(BYREF T AS STRING)
  VAR w = "", l = 0, i = 0, lt = LEN(T)
  WHILE i < lt
    SELECT CASE AS CONST CHAR_TYP(T[i]) + 5
    CASE 0 TO 2 : l += 1 '                                 "_", A-Z, a-z
    CASE 3 : IF l THEN l += 1 ELSE PRINT #Fnr, CHR(T[i]); '        0 - 9
    CASE ELSE
      IF l THEN w = MID(T, i - l + 1, l) : l = 0 : PRINT #Fnr, *Co->Post.rep(w);
      PRINT #Fnr, CHR(T[i]);
    END SELECT : i += 1
  WEND : IF l THEN w = MID(T, i - l + 1) : PRINT #Fnr, *Co->Post.rep(w);
END SUB

' stores new translation in RES
' speichert neues Uebersetzungergebnis in RES
SUB BiWriter.add(BYREF T AS STRING, BYVAL Fl AS INTEGER = 0)
  VAR r = "", mo = Op->Art_Co
  IF LaWo = CHR(1) THEN mo += &b1
  IF Er->FLE THEN IF Op->I.ER THEN Op->I.RAUS = 1 : r = NL
  IF Op->I.Sep_ THEN PRINT #Fnr, In->readCCom(mo + &b10);
  IF ASC(T) THEN
    SELECT CASE AS CONST T[0]
    CASE ASC("'") : IF LEFT(LaWo, 1) <> "'" THEN r = NL
    CASE ASC("#")
      SELECT CASE LaWo
      CASE "#END" : IF LEFT(T, 4) = "#DEF" OR LEFT(T, 3) = "#IF" THEN r = NL
      CASE "#DEF" : IF LEFT(T, 3) = "#IF" THEN r = NL
      CASE ELSE : IF LEFT(LaWo, 1) <> "#" THEN r = NL
      END SELECT
    CASE ELSE
      IF LaWo <> LEFT(T, 4) THEN r = NL
    END SELECT : IF LEN(LaWo) THEN PRINT #Fnr, r

    IF LaWo = CHR(1) THEN
      LaWo = LCASE(LEFT(T, 4))
    ELSE
      LaWo = LEFT(T, 4)
    END IF : r = "" : mo += &b100

    IF Op->I.RAUS THEN
      r = In->readCCom(mo + &b1000)
    ELSE
      IF Op->I.Sep_ THEN r = In->readCCom(mo)
    END IF : IF LEN(r) THEN PRINT #Fnr, r

    IF Op->C.PO THEN IF Fl = 0 THEN writePostReps(T) ELSE PRINT #Fnr, T;
    PRINT #Fnr, Er->show();
  ELSE
    IF Op->I.RAUS THEN
      r = TRIM(In->readCCom(mo OR &b11100), TRIMM)
      IF ASC(r) THEN
        IF LEFT(LaWo, 1) <> "'" THEN LaWo = "'" : PRINT #Fnr, NL;
        PRINT #Fnr, genKom(r);
      END IF
    END IF
  END IF : Op->I.RAUS = 0
END SUB
