TYPE H_2_Bi
  DECLARE CONSTRUCTOR
Private:
  AS ErrorHandler PTR Er
  AS CFileReader PTR In
  AS BiWriter PTR Ou
  AS Options PTR Op
  AS Macros PTR Ma
  AS Config PTR Co
  AS STRING Tex, Nam, Typ
  AS INTEGER ModI, ModO, Ebne, BlNr
  AS STRING BlXx, BlRp, BlVo
  AS STRING Cdec, Byva, Einr, Tabz
  AS STRING IfNa, BlTy

  DECLARE FUNCTION Act(BYREF F AS STRING) AS INTEGER
  DECLARE FUNCTION Line_() AS STRING
  DECLARE FUNCTION PreCo() AS STRING
  DECLARE FUNCTION Block(BYVAL A AS INTEGER = 0) AS STRING

  DECLARE FUNCTION addZStrDim(BYREF T AS STRING) AS STRING
  DECLARE FUNCTION genDefLine(BYREF Pr AS STRING) AS STRING
  DECLARE FUNCTION genFieldDim(BYREF Di AS STRING, BYVAL Zp AS INTEGER) AS STRING
  DECLARE FUNCTION ParaList(BYVAL A AS INTEGER, BYVAL L AS INTEGER) AS STRING
  DECLARE SUB checkNaTy()
  DECLARE SUB checkTy()
  DECLARE SUB translate()

  DECLARE FUNCTION UnsaveDefine() AS INTEGER
  DECLARE FUNCTION checkCast(BYVAL Aa AS INTEGER, BYVAL Ee AS INTEGER, _
                   BYREF Lt AS INTEGER, _
                   BYVAL Az AS INTEGER, Pa() AS STRING) AS INTEGER
  DECLARE FUNCTION genCast(BYREF P AS INTEGER, BYREF Lt AS INTEGER) AS INTEGER
  DECLARE FUNCTION genLogic(BYREF T AS STRING, BYVAL Mo AS INTEGER = 0) AS STRING
  DECLARE FUNCTION genIfComment(BYVAL Mo AS INTEGER = 0) AS STRING
  DECLARE SUB genIif(BYVAL Aa AS INTEGER, BYVAL Lt AS INTEGER)
  DECLARE SUB genQuoteNLogic(BYREF T AS STRING, BYVAL Aa AS INTEGER, _
                             BYREF Lt AS INTEGER, BYVAL Mo AS INTEGER = 0)

  DECLARE FUNCTION BlockENUM() AS STRING
  DECLARE FUNCTION BlockTyUn() AS STRING
  DECLARE SUB BlockName(BYVAL Mo AS INTEGER)
  DECLARE SUB insertBlNa(BYREF Na AS STRING)
  DECLARE SUB fillTYXX(BYVAL Lt AS INTEGER)

  DECLARE FUNCTION checkFileNam(BYREF F AS STRING) AS STRING
  DECLARE SUB read2(BYREF S AS STRING, BYVAL Mo AS INTEGER = 0)
END TYPE

CONSTRUCTOR H_2_Bi
  Op = NEW Options(COMMAND)
  IF Op->RunMod <> 1 THEN
    MSG_WELLCOME
    IF LEN(Op->Msg) THEN ? Op->Msg
    SELECT CASE AS CONST Op->RunMod
    CASE 0
      ? "  Directory: " & CURDIR
      IF LEN(COMMAND) THEN
        ? "   Cmd-line: " & COMMAND;
      ELSE
        ? "  Default configuration (no parameters specified).";
      END IF
      IF LEN(Op->Jobs) = 0 THEN
        IF noH2Bi(Op->Jobs) THEN DELETE Op : EXIT CONSTRUCTOR
        Op->Jobs &= CHR(1)
      END IF
    CASE 2 : MSG_VERSION : DELETE Op : EXIT CONSTRUCTOR
    CASE ELSE : MSG_HELP : DELETE Op : EXIT CONSTRUCTOR
    END SELECT
  ELSE
    Op->Jobs = !"Geany\001" : CHDIR EXEPATH
  END IF
  VAR e1 = 0
  DO '                                                  all Jobs (.h2bi)
    VAR a1 = e1 + 1 : e1 = INSTR(a1, Op->Jobs, CHR(1)) : IF e1 <= a1 THEN EXIT DO
    VAR job = MID(Op->Jobs, a1, e1 - a1)
    In = NEW CFileReader(job & H2BI_FILE_SUFFIX) : VAR inmsg = In->Erro()
    IF inmsg THEN
      ? *inmsg & job & H2BI_FILE_SUFFIX
    ELSE
      Er = NEW ErrorHandler(Op->O.ER + 2 * Op->O.ET)
      Co = NEW Config(In, Op) : IF Op->RunMod <> 1 THEN ? NL & Co->Msg;
      Ma = NEW Macros(Co->Macros, Op, Er)
      Ou = NEW BiWriter(job, Co, Op, Ma, In, Er)
      IF Ou->Deep = 0 THEN
        Op->Art_Co = Op->FLI AND MASK_FLI
        IF Op->O.CD THEN Cdec = " CDECL"
        IF Op->O.BV THEN Byva = "BYVAL "
        IF Op->Tabs < 0 THEN Tabz = !"\t" ELSE Tabz = STRING(Op->Tabs, 32)
        IF Op->RunMod = 1 THEN
          Act("")
        ELSE
          VAR a2 = 1, e2 = INSTR(a2, Co->FNams, ";")
          WHILE e2 > a2
            IF Act(MID(Co->FNams, a2, e2 - a2)) THEN ? Tex
            a2 = e2 + 1 : e2 = INSTR(a2, Co->FNams, ";")
          WEND
        END IF
      END IF : DELETE Ou
      DELETE Ma
      DELETE Co
      DELETE Er
    END IF : DELETE In
  LOOP UNTIL e1 >= LEN(Op->Jobs) : DELETE Op
END CONSTRUCTOR

' translation
' wertet Eingabe aus (.h oder stdin)
FUNCTION H_2_Bi.Act(BYREF F AS STRING) AS INTEGER
  IF LEN(F) THEN Tex = checkFileNam(F) : IF LEN(Tex) THEN RETURN -1
  VAR oldIn = In : Tex = In->FNam : In = NEW CFileReader(F)
  VAR m = In->Erro() : IF m THEN Tex = *m & F : In = oldIn : RETURN -2
  Ou->In = In : Ebne += 1 : IF Ebne > Ou->Deep THEN Ou->Deep = Ebne
  IF LEN(F) THEN IF Op->O.MF THEN Ou->add(FILE_START(Ebne) & Tex & " ==> " & F, 1)
  IF Op->RunMod <> 1 THEN ?"==> "; F
  WHILE In->weGo() : Einr = ""
    read2(!";#{}=")
    SELECT CASE AS CONST In->LaCh()
    CASE ASC("#") : Ou->add(PreCo())
    CASE ASC("}") : Ou->add(Block())
    CASE ASC("{")
      VAR i = 0 : i = IIF(nextWord(In->Tex, i) = "typedef", i, 0)
      Ou->add(Block(i))
    CASE ASC(";"), ASC("="), ASC(!"\n"), 0
      IF In->LaCh() = ASC("=") THEN
        In->Tex &= "=" : IF In->weGO() THEN read2(";") ' !!! #-PreCo Zeilen
      END IF : IF LEN(In->Tex) THEN Ou->ADD(Line_())
    CASE ELSE : EXIT WHILE
    END SELECT : In->newTex()
  WEND : Ou->In = oldIn : DELETE In : In = oldIn
  IF LEN(F) THEN IF Op->O.MF THEN Ou->add(INCLU_BACK(Ebne) & In->FNam & " ==> " & F, 1)
  Ebne -= 1 : RETURN 0
END FUNCTION

' reades to one of the S characters, Mo = 1 : new block
' liest bis zu einem der Zeichen von S, Mo = 1 : neuer Block
SUB H_2_Bi.read2(BYREF S AS STRING, BYVAL Mo AS INTEGER = 0)
  IF Mo THEN In->newTex()
  WHILE In->weGo()
    In->readTo(S)
    VAR bl = ";" : In->Tex = Ma->expand(In->Tex, bl)
    Kompri(In->Tex, 1)
    IF In->LaCh() <> ASC(!"\n") THEN EXIT SUB
    IF LEN(In->Tex) THEN EXIT SUB
  WEND
END SUB

' returns matching comment for '#endif'
' liefert passenden Kommentar fuer '#endif'
FUNCTION H_2_Bi.genIfComment(BYVAL Mo AS INTEGER = 0) AS STRING
  IF Op->O.MI = 0 ORELSE LEN(IfNa) = 0 THEN RETURN ""
  VAR p = INSTRREV(IfNa, CHR(1)) : IF Mo THEN RETURN " ' " & MID(IfNa, p + 1)
  VAR r = MID(IfNa, p + 1) : IfNa = LEFT(IfNa, p - 1) : RETURN " ' " & r
END FUNCTION

' generates a line for ZSTRING declaration
' erzeugt eine Deklarationszeile fuer ZSTRING
FUNCTION H_2_Bi.addZStrDim(BYREF T AS STRING) AS STRING
  IF MID(T, 1, 4) = "*???" THEN
    IF INSTR(T, "=") THEN
      DIM AS INTEGER az = INSTRREV(T, """") - INSTR(T, """") - 1
      T = "*" & STR(az) & MID(T, 5) : Er->E.USDI = 1
    ELSE
      MID(T, 1, 4) = " PTR" : Er->E.NODI = 1 : RETURN T
    END IF
  END IF : IF INSTR(T, "???") THEN Er->E.NODI = 1 : RETURN T
  RETURN T
END FUNCTION

' generates line to define one (or more) type(s)
' erzeugt Zeile(n) zur Definition von Typen
FUNCTION H_2_Bi.genDefLine(BYREF Pr AS STRING) AS STRING
  IF BIT(ModO, 5) THEN '                        entry for parameter list
    IF Er->E.PATY THEN
      Typ = Nam & Typ : Nam = "" : Er->E.PANA = 1
      IF LEN(Typ) THEN Er->E.PATY = 0
    END IF
    IF Op->O.NA = 0 THEN Er->E.PANA = 0 : RETURN "AS " & Typ
    IF LEN(Nam) = 0 THEN Er->E.PANA = 1 : IF Op->T.UV THEN Nam = TYKENN
    RETURN Nam & " AS " & Typ
  END IF
  SELECT CASE AS CONST ModO
  CASE 0
    IF ASC(Pr) = ASC("T") THEN RETURN Pr & Nam & " AS " & Typ
    RETURN Pr & "AS " & Typ & " " & Nam
  CASE 1
    RETURN Pr & "AS " & Typ & " " & Nam
  CASE 2
    IF ASC(Pr) = ASC("T") THEN RETURN "DIM AS " & Typ & " " & Nam
    RETURN Pr & "AS " & Typ & " " & Nam
  CASE 3
    VAR p = INSTR(Nam, !"\t")
    IF ASC(Pr) = ASC("T") THEN
      IF p <= 1 THEN RETURN "DIM " & "AS " & Typ & " PTR " & MID(Nam, p + 1)
      RETURN Pr & "AS " & Typ & " " & LEFT(Nam, p - 1) & NL & _
            "DIM " & "AS " & Typ & " PTR " & MID(Nam, p + 1)
    END iF
    IF p <= 1 THEN RETURN Pr & "AS " & Typ & " " & MID(Nam, p + 1)
    RETURN Pr & "AS " & Typ & " " & LEFT(Nam, p - 1) & ", " & MID(Nam, p + 1)
  CASE 4, 5
    RETURN "' ??? " & Pr & "AS " & Typ & " " & Nam
  CASE 6, 7
    VAR r = "", p = 0, a = INSTR(Nam, !"\t") + 1
    IF a > 2 THEN r = Pr & "AS UBYTE " & LEFT(Nam, a - 2) & NL ELSE a = 1
    r &= Pr & "AS " & Typ
    DO
      p = INSTR(a, Nam, ", *")
      IF p = 0 THEN r &= addZStrDim(MID(Nam, a)) : EXIT DO
      r &= addZStrDim(MID(Nam, a, p - a)) & NL & Pr & "AS " & Typ
      a = p + 2
    LOOP : RETURN r
  CASE ELSE
    IF ASC(Pr) = ASC("T") THEN RETURN Pr & Nam & " AS " & Typ
    IF ASC(Pr) = ASC(Tabz) THEN RETURN Pr & Nam & " AS " & Typ
    IF Op->T.PT THEN IF STACK_FIN(Ou->SuFu, Nam) = 0 THEN STACK_ADD(Ou->SuFu, Nam)
    Op->I.RAUS = Op->I.DE : IF Op->T.DE = 0 THEN RETURN ""
    SELECT CASE AS CONST ModO
    CASE  8 : RETURN "DECLARE SUB " & Nam & MID(Typ, 4)
    CASE 16 : RETURN "DECLARE FUNCTION " & Nam & MID(Typ, 9)
    CASE 9 TO 11, 17 TO 31 : RETURN "DIM AS " & Typ & " " & Nam
    END SELECT
  END SELECT : Er->E.UNDE = 1 : RETURN Pr & Nam & " AS " & Typ
END FUNCTION

' translates a single line
' uebersetzt einzelne Zeile
FUNCTION H_2_Bi.Line_() AS STRING
  VAR i = 0, Text = ""
  SELECT CASE nextWord(In->Tex, i)
  CASE "typedef" : IF Op->T.TY = 0 THEN RETURN ""
    Op->I.RAUS = Op->I.TY : i += 2 : ModI = &b00001011 : Text = "TYPE "
  CASE "struct", "enum", "union", "class": IF Op->T.TY = 0 THEN RETURN ""
    Op->I.RAUS = Op->I.TY : i = 1  : ModI = &b00001011 : Text = "TYPE "
  CASE "static" : IF Op->T.ST = 0 THEN RETURN ""
    Op->I.RAUS = Op->I.ST : i += 2 : ModI = &b00001011 : Text = "STATIC "
  CASE "const" : IF Op->T.CO = 0 THEN RETURN ""
    Op->I.RAUS = Op->I.CO : i += 2 : ModI = &b01001010 : Text = "CONST "
  CASE "extern" : IF Op->T.EX = 0 THEN RETURN ""
    Op->I.RAUS = Op->I.EX : i += 2 : ModI = &b00011001 : Text = "EXTERN "
  CASE ELSE : IF Op->T.DI = 0 THEN RETURN ""
    Op->I.RAUS = Op->I.DI : i = 1  : ModI = &b10001011 : Text = "DIM "
  END SELECT
  Tex = LTRIM(MID(In->Tex, i), TRIMM)
  translate()
  IF Er->E.NONA ANDALSO Er->E.NOTY THEN RETURN ""
  IF Er->E.NOTY THEN
    IF Text[0] = ASC("T") THEN
      IF Op->T.UT ANDALSO STACK_FIN(Ou->TyNa, Nam) = 0 THEN _
         STACK_ADD(Ou->TyNa, Nam) : Typ = Nam & TYKENN
    ELSE
      IF Op->T.AN THEN IF LEN(Typ) THEN Typ = "ANY " & Typ ELSE Typ = "ANY PTR"
    END IF
  ELSE
    IF Op->T.UT ANDALSO Typ = Nam THEN _
       IF STACK_FIN(Ou->TyNa, Nam) = 0 THEN STACK_ADD(Ou->TyNa, Nam) : Typ = Nam & TYKENN
  END IF : RETURN genDefLine(Text)
END FUNCTION

' generates a FB field dimension
' erzeugt eine FB Feld-Dimensionierung, wenn eingeschaltet
FUNCTION H_2_Bi.genFieldDim(BYREF Di AS STRING, BYVAL Zp AS INTEGER) AS STRING
  VAR i = 1, l = 0, az = 0, t = "", r = ""
  WHILE i < LEN(Di)
    l = CVI(MID(Di, i, 4))
    i += 4
    IF l THEN
      t = TRIM(MID(Di, i, l), TRIMM)
      IF t[0] >= ASC("A") THEN IF checkFbKw(t, Op->T.KW) THEN t &= TYKENN
      i += l
      IF Op->O.NT THEN
        r &= "0 TO " & t & "-1"
      ELSE
        l = VALINT(t)
        IF l THEN r &= STR(l - 1) ELSE r &= t & "-1"
      END IF
    ELSE
      t = "???" : r &= t : Er->E.NODI = 1
    END IF : r &= ", " : az += 1
  WEND : IF Zp = 0 THEN RETURN "(" & RTRIM(r, ", ") & ")"
  Di = t : IF az = 1 THEN RETURN ""
  RETURN "(" & LEFT(r, INSTRREV(RTRIM(r, ", "), ",") - 1) & ")"
END FUNCTION

' replaces array dimensions in VAR names
' ersetzt Feldgroessen in Variablennamen: [5][10] -> (0 TO 5-1, 0 TO 10-1)
SUB H_2_Bi.checkNaTy()
  DIM AS INTEGER l, az, ln = LEN(Nam), e
  DIM AS STRING n, n1, n3, zu, di, al
  VAR zp = IIF(RIGHT(" " & Typ, 8) = " ZSTRING", LEN(Typ) - 6, 0)
  Nam &= ","
  FOR i AS INTEGER = 0 TO ln
    SELECT CASE AS CONST Nam[i]
    CASE ASC("="), ASC(":") '                      init [ : or = {...} ]
      e = findBlockEnd(Nam, i, ln, ASC(","))
      IF e >= 0 THEN
        IF BIT(ModI, 1) THEN
          l = e - i - 1
          zu = " " & CHR(Nam[i]) & " " & LTRIM(MID(Nam, i + 2, l), TRIMM)
          i = 3 : l += 1 : genQuoteNLogic(zu, i, l, 1)
        END IF : i = e - 1
      END IF
    CASE ASC("[") '                                 dimension [][xyz][5]
      e = findBlockEnd(Nam, i, ln)
      IF e >= 0 THEN
        l = e - i - 1
        VAR r = MID(Nam, i + 2, l)
        l = LEN(r) - 1 : genQuoteNLogic(r, 0, l, 1)
        di &= MKI(l + 1) & r
        i = e
      END IF
    CASE ASC(",")
      IF BIT(ModI, 4) THEN IF Op->O.AL THEN al = " ALIAS """ & n & """"
      IF BIT(ModI, 3) THEN IF checkFbKw(n, Op->T.KW) THEN n &= TYKENN

      IF BIT(ModI, 2) THEN '                         paralist/SuFu modus
        IF LCASE(n) = "as" THEN n &= TYKENN
        IF LEN(di) THEN
          IF BIT(ModI, 0) = 0 THEN IF LEN(Typ) THEN Typ &= " PTR"
        ELSE
          IF zp THEN Typ = LEFT(Typ, zp - 1) & "UBYTE" : Er->E.NODI = 0
          Typ &= zu
        END IF : Nam = n : ModO = 0 : EXIT SUB
      END IF

      IF LEN(di) = 0 ANDALSO LEN(zu) = 0 THEN
        n1 &= n & al & ", " : al = ""
      ELSE
        IF LEN(di) THEN '                           dimension (0 TO ...)
          IF BIT(ModI, 0) THEN
            n &= genFieldDim(di, zp)
            IF zp THEN n = "*" & di & " " & n
          END IF : di = ""
        END IF : n3 &= n & zu & ", " : zu = ""
      END IF : n = "" : az += 1
    CASE ELSE
      IF CHAR_TYP(Nam[i]) < 0 THEN n &= CHR(Nam[i])
    END SELECT
  NEXT : az = IIF(az > 1, 1, 0) + IIF(zp, 4, 0)
  IF LEN(n3) = 0 THEN
    IF zp THEN Typ = LEFT(Typ, zp - 1) & "UBYTE" : Er->E.NODI = 0 : az -= 4
    Nam = RTRIM(n1, ", ") : ModO = az : EXIT SUB
  ELSEIF LEN(n1) = 0 THEN
    IF BIT(ModI, 0) = 0 THEN IF LEN(Typ) THEN Typ &= " PTR"
    Nam = RTRIM(n3, ", ") : ModO = 2 + az : EXIT SUB
  END IF : Nam = RTRIM(n1, ", ") & !"\t" & RTRIM(n3, ", ") : ModO = 2 + az
END SUB

' checks types, replaces by definition in TYPES
' prueft types, ersetzt ggf. gemaess TYPES
SUB H_2_Bi.checkTy()
  VAR l = 0, az = 0, fl = 0
  FOR i AS INTEGER = 0 TO LEN(Typ) - 1
    SELECT CASE AS CONST Typ[i]
    CASE 0 : EXIT FOR
    CASE 1 TO 32 : IF l THEN fl = 1
    CASE ASC("*") : az += 1 : IF l THEN fl = 1
    CASE ELSE
      IF fl THEN Typ[l] = ASC(" ") : l += 1 : fl = 0
      Typ[l] = Typ[i] : l += 1
    END SELECT
  NEXT : Typ = LEFT(Typ, l) & " " : l += 1
  VAR r = ""
  WHILE l
    DO
      fl = 1
      WITH Co->Typ_
        VAR a = 6, e = INSTR(.Su, CHR(2))
        WHILE e > a
          VAR ls = e - a : e += 1
          VAR x = INSTR(e, .Su, CHR(1))
          IF LEFT(Typ, ls) = MID(.Su, a, ls) THEN
            Typ = MID(Typ, ls + 1)
            VAR z = SADD(.Er) + VALINT("&H" & MID(.Su, e, x - e))
            *CAST(INTEGER PTR, z - 4) += 1
            l -= ls
            IF z[0] THEN r &= *z & " "
            fl = 0 : EXIT WHILE
          END IF : a = x + 1 : e = INSTR(a, .Su, CHR(2))
        WEND : IF l <= 0 THEN EXIT WHILE
      END WITH
    LOOP UNTIL fl
    VAR p = INSTR(Typ, " ") - 1, n = LEFT(Typ, p)
    IF Op->T.KW THEN IF checkFbKw(n) THEN n &= TYKENN
    IF p <= l THEN r &= n & " " ELSE r &= n : EXIT WHILE
    Typ = MID(Typ, p + 2) : l -= p + 1
  WEND : Typ = RTRIM(r) :
  IF LEN(Typ) = 0 THEN
    'IF Op->T.AN THEN Typ = "ANY PTR" ELSE Er->E.NOTY = 1
    Er->E.NOTY = 1
  ELSE
    IF Typ = "UNSIGNED" THEN Typ = "UINTEGER"
    IF Op->T.PT THEN IF STACK_FIN(Ou->SuFu, Typ) THEN az -= 1
  END IF : FOR i AS INTEGER = 1 TO az : Typ &= " PTR" : NEXT
END SUB

' generates name and type of a C declination (type may be a FB SUB/FUNCTION)
' wandelt C-Deklaration in Name und Typ (Typ ist ggf. FB SUB/FUNCTION)
' ModI wirkt in: translate, checkNaTy
' 0: allow field dimensioning
' 1: Initialisierung (= ... | : ...)
' 2: only one name (no ,)
' 3: FB keyword check
' 4: ALIAS fuer name (not SUB | FUNCTION)
' 5: parameter list mode
' 6: const mode
' 7: alias mode
SUB H_2_Bi.translate()
  Nam = "" : Typ = ""
  VAR p = -2, kl = 0, a1 = -1, e1 = -1, a2 = -1, e2 = -1, a0 = -1, lt = LEN(Tex) - 1
  FOR i AS INTEGER = lt TO 0 STEP -1
    SELECT CASE AS CONST Tex[i]
    CASE ASC("(")
      kl += 1
      IF kl <> 0 THEN a0 = i ELSE IF a2 < 0 THEN a2 = i ELSE a1 = i
    CASE ASC(")")
      IF kl = 0 THEN IF e2 < 0 THEN e2 = i ELSE e1 = i
      kl -= 1
    CASE ASC("[") : kl += 1
    CASE ASC("]") : kl -= 1
    CASE ASC("*") : IF kl = 0 THEN p = IIF(p < 0, i, p) ': EXIT FOR
    CASE ASC(" ") : IF p = -1 THEN IF kl = 0 THEN p = i
    CASE ASC(","), ASC(":"), ASC("=") : p = -2
    CASE ELSE : IF p < -1 THEN IF kl = 0 THEN IF CHAR_TYP(Tex[i]) < -2 THEN p = -1
    END SELECT
  NEXT
  VAR mo = ModI : IF a2 > 0 THEN ModI = &b0000100 : lt = a2 - 1
  IF a1 > 0 THEN '                                    type (*name) (...)
    IF a0 < 0 THEN
      Nam = TRIM(MID(Tex, a1 + 2, e1 - a1 - 1), TRIMM & "*")
      Typ = TRIM(LEFT(Tex, a1), TRIMM) : checkTy() : checkNaTy()
    ELSE '                               unsupported: type ((...)) (...)
      a2 = 0
      FOR p = a1 + 1 TO a0
        IF Tex[p] = ASC("*") THEN Tex[p] = ASC(" ") : a2 += 1
      NEXT : Tex = LEFT(Tex, a1) & " " & MID(Tex, a1 + 2, e1 - a1 - 1)
      translate() : FOR p = 1 TO a2 : Typ &= " PTR" : NEXT
      ModO OR= &b1000000 : EXIT SUB
    END IF
  ELSEIF p > 0 THEN '                                  type name [(...)]
    Nam = TRIM(MID(Tex, p + 2, lt - p + 1), TRIMM)
    Typ = LEFT(Tex, p + 1) : checkTy() : checkNaTy()
  ELSE '                                                         no type
    IF BIT(ModI, 5) THEN '                parameter list, no name needed
      Er->E.NONA = 1 : Typ = LEFT(Tex, lt + 1) : checkTy() : ModO = 0
    ELSE
      IF a2 > 0 THEN  '         name in brackets, ie: void (*_reserved);
        Nam = TRIM(MID(Tex, a2 + 2, e2 - a2 - 1), TRIMM & "*")
        Typ = TRIM(LEFT(Tex, a2), TRIMM) : checkTy() : checkNaTy() : e2 = a2 + 1
      ELSE '                           just a name, ie typedef someName;
        Er->E.NOTY = 1 : Nam = LEFT(Tex, lt + 1) : checkNaTy()
      END IF
    END IF
  END IF : IF a2 < 0 THEN EXIT SUB

  IF Er->E.NOTY THEN Typ = "???" : ModO = 64
  Er->shift(SHIFT_SUFU)
  IF INSTR(Nam, ANY ";*") THEN Er->E.CHNA = 1
  IF INSTR(Nam, "void") THEN Er->E.CHNA = 1
  VAR pl = Cdec
  IF BIT(mo, 7) THEN IF Op->O.AL THEN pl &= " ALIAS """ & Nam & """"
  IF checkFbKw(Nam, Op->T.KW) THEN Nam &= TYKENN
  VAR ty = " AS "
  VAR na = Nam
  IF Typ = "ANY" ANDALSO INSTR(" " & LEFT(Tex, a2) & " ", " void ") THEN
    mo = ModO + 8
  ELSE
    IF BIT(mo, 6) THEN ty &= "CONST "
    ty &= Typ : mo = ModO + 16
  END IF
  pl &= ParaList(a2 + 2, e2 - a2 - 1) : Nam = na : ModO = mo
  IF ModO < 16 THEN Typ = "SUB" & pl : EXIT SUB
  Typ = "FUNCTION" & pl & ty
END SUB

#MACRO TRANS_PARA(le)
  ModI = &b100110 : translate()
  IF Er->E.NONA THEN
    IF Op->O.NA = 0 THEN Er->E.NONA = 0 ELSE IF Op->T.UV THEN Nam = TYKENN
  END IF : Er->shift(SHIFT_PARA)
  ModO OR= &b100000 : r &= Byva & genDefLine("AS ") & le
#ENDMACRO

' generates FB parameter list from C parameter list
' generiert FB-Parameterliste aus C-Parameterliste
FUNCTION H_2_Bi.ParaList(BYVAL A AS INTEGER, BYVAL L AS INTEGER) AS STRING
  VAR t = TRIM(MID(Tex, A, L), TRIMM) : IF t = "void" THEN RETURN "()"
  VAR lt = LEN(t) - 1 : IF lt < 0 THEN RETURN "()"
  DIM AS STRING r, le = ", "
  DIM AS INTEGER p, e = findBlockEnd(t, 0, lt, ASC(","))
  Einr &= Tabz
  IF Op->O.WR THEN r = " _" & NL & Einr : le &= MID(r, 2)
  WHILE e > p
    Tex = TRIM(MID(t, p + 1, e - p), TRIMM)
    TRANS_PARA(le)
    p = e + 1 : e = findBlockEnd(t, p, lt, ASC(","))
  WEND : Tex = TRIM(MID(t, p + 1), TRIMM)
  IF Tex = "..." THEN
    r &= Tex
  ELSE
    TRANS_PARA("")
  END IF : Einr = LEFT(Einr, LEN(Einr) - LEN(Tabz)) : RETURN "(" & r & ")"
END FUNCTION

' returns 1 if context of () may be a cast (or 0)
' liefert 1 wenn Zeichenkette CAST sein kann, sonst 0
FUNCTION H_2_Bi.checkCast(BYVAL Aa AS INTEGER, BYVAL Ee AS INTEGER, _
                          BYREF Lt AS INTEGER, _
                          BYVAL Az AS INTEGER, Pa() AS STRING) AS INTEGER
  WITH *In
    IF CHAR_TYP(.Tex[Aa + 1]) > -3 THEN RETURN 0
    DIM AS INTEGER i, p, fl
    FOR i = Aa + 2 TO Ee - 1
      IF CHAR_TYP(.Tex[i]) >= 0 THEN IF INSTR(!" *#\t", CHR(.Tex[i])) = 0 THEN RETURN 0
    NEXT : Typ = MID(.Tex, Aa + 2, Ee - Aa - 1)
    checkTy() : IF Er->E.NOTY THEN Er->E.NOTY = 0 : RETURN 0
    FOR i = 0 TO Az
      STRreplace(Typ, Pa(i) & TYKENN, Pa(i))
    NEXT : p = skipTrenn(.Tex, Ee + 1, Lt) : IF p > Lt THEN RETURN 0
    IF INSTR("*&-+!~", CHR(.Tex[p])) THEN
      fl = -1 : p += 1 : IF Op->T.CU = 0 THEN RETURN 0
    END IF
    p = skipTrenn(.Tex, p, Lt) : IF p <= Lt THEN i = p ELSE RETURN 0
    IF CHAR_TYP(.Tex[p]) > -2 ANDALSO .Tex[p] <> ASC("(") THEN RETURN 0
    WHILE CHAR_TYP(.Tex[p]) < 0 ORELSE .Tex[p] = ASC("#")
      p += 1 : IF p > Lt THEN RETURN 0
    WEND : VAR s = "(" : IF p > i THEN s &= "["
    i = skipTrenn(.Tex, p, Lt) : IF i > Lt THEN RETURN 0
    IF INSTR(s, CHR(.Tex[i])) THEN
      p = findBlockEnd(.Tex, i, Lt) + 1 : IF p < 1 THEN RETURN 0
    END IF
    VAR neu = LTRIM(MID(.Tex, Ee + 2, p - Ee - 1)) : IF LEN(neu) = 0 THEN RETURN 0
    IF fl THEN IF Op->O.UC THEN Er->E.USCA = 1 ELSE RETURN 0
    VAR w = "CAST(" : IF CHAR_TYP(.Tex[Aa - 1]) < 0 THEN w = " " & w
    .Tex = LEFT(.Tex, Aa) & w & Typ & ", " & neu & ")" & MID(.Tex, p + 1)
    Lt = LEN(.Tex) - 1
  END WITH : RETURN 1
END FUNCTION

' checks #define line, translates CASTs into FB source, returns start pos
' prueft #define-Zeile, wandelt CASTs in FB Quelltext, liefert Startpos
FUNCTION H_2_Bi.genCast(BYREF P AS INTEGER, BYREF Lt AS INTEGER) AS INTEGER
  REDIM AS STRING pa(0)
  VAR az = -1 , n = nextWord(In->Tex, P)
  IF checkFbKw(n, Op->T.KW) THEN
    In->Tex = LEFT(In->Tex, P) & TYKENN & MID(In->Tex, P + 1)
    P += LEN(TYKENN) : Lt += LEN(TYKENN)
  END IF : IF P >= Lt THEN RETURN 0
  IF In->Tex[P] = ASC("(") THEN az = Ma->getParList(In->Tex, P, Lt, pa())
  'P = skipTrenn(In->Tex, P, Lt)
  IF Op->T.CS = 0 ANDALSO Op->T.CU = 0 THEN RETURN 0
  VAR a = Lt + 1, e = 0, fl = 0
  WHILE a >= P
    a = INSTRREV(In->Tex, "(", a) - 1 : IF a < P THEN RETURN fl
    e = findBlockEnd(In->Tex, a, Lt) : IF e < 0 OR e >= Lt THEN RETURN fl
    IF checkCast(a, e, Lt, az, pa()) THEN fl += 1
  WEND : RETURN fl
END FUNCTION

' checks T for C logic, replaces by FB commands and numbers
' prueft T auf C-LogiK-Befehle, ersetzt sie durch FB-Befehle bzw. Zahlen
FUNCTION H_2_Bi.genLogic(BYREF T AS STRING, BYVAL Mo AS INTEGER = 0) AS STRING
  IF Op->T.LO = 0 THEN RETURN T
  VAR fl = 0, lt = LEN(T) - 1 : IF lt <= 0 THEN RETURN T
  DIM AS STRING r, _or, _and, _not
  IF Mo THEN _or = "ORELSE" : _and = "ANDALSO" : _not = "0 =" _
        ELSE _or = "OR" : _and = "AND" : _not = "NOT"
  FOR i AS INTEGER = 0 TO lt
    SELECT CASE AS CONST fl
    CASE 2 '                                                      indent
      SELECT CASE AS CONST T[i]
      CASE ASC(!"\t"), ASC(" ") : r &= " "
      CASE ELSE : fl = 0
      END SELECT
    CASE 3 '                                                     decimal
      SELECT CASE AS CONST T[i]
      CASE ASC("0") TO ASC("9") : r &= CHR(T[i])
      CASE ELSE : fl = 0
      END SELECT
    CASE 4 '                                                 hexadecimal
      SELECT CASE AS CONST T[i]
      CASE ASC("0") TO ASC("9") : r &= CHR(T[i])
      CASE ASC("a") TO ASC("f") : r &= UCASE(CHR(T[i]))
      CASE ASC("A") TO ASC("F") : r &= CHR(T[i])
      CASE ELSE : fl = 0
      END SELECT
    CASE 5 '                                                       octal
      SELECT CASE AS CONST T[i]
      CASE ASC("0") TO ASC("7") : r &= CHR(T[i])
      CASE ELSE : fl = 0
      END SELECT
    CASE 6 '                                                leading zero
      SELECT CASE AS CONST T[i]
      CASE ASC("0") TO ASC("7") : r &= "&o" & CHR(T[i]) : fl = 5
      CASE ASC("8"), ASC("9") : r &= "0" & CHR(T[i]) : fl = 3
      CASE ASC("x"), ASC("X") : r &= "&h" : fl = 4
      CASE ELSE : r &= "0" : fl = 0
      END SELECT
    CASE 32 : IF T[i] > ASC(" ") THEN r &= " " : fl = 0
    CASE ASC("!")
      SELECT CASE AS CONST T[i]
      CASE ASC("=") : r &= "<>" : fl = 1
      CASE ELSE : r &= _not : fl = 0 : IF T[i] > 32 THEN r &= " "
      END SELECT
    CASE ASC(">") : IF T[i] = ASC(">") THEN r &= "SHR" : fl = 32 ELSE r &= ">" : fl = 0
    CASE ASC("<") : IF T[i] = ASC("<") THEN r &= "SHL" : fl = 32 ELSE r &= "<" : fl = 0
    CASE ASC("|")
      SELECT CASE AS CONST T[i]
      CASE ASC("|") : r &= _or : fl = 32
      CASE ASC("=") : r &= "OR=" : fl = 1
      CASE ELSE : r &= "OR" : fl = 0 : IF T[i] > 32 THEN r &= " "
      END SELECT
    CASE ASC("&")
      SELECT CASE AS CONST T[i]
      CASE ASC("&") : r &= _and : fl = 32
      CASE ASC("=") : r &= "AND=" : fl = 1
      CASE ELSE
        IF CHAR_TYP(T[i]) <= -3 ORELSE T[i] = ASC("(") THEN
          r &= "@" : fl = 0
        ELSE
          r &= "AND" : fl = 0 : IF T[i] > 32 THEN r &= " "
        END IF
      END SELECT
    CASE ASC("=")
      IF CHAR_TYP(r[LEN(r) - 1]) < -1 THEN r &= " "
      r &= "=" : IF T[i] = ASC("=") THEN fl = 1 ELSE fl = 0
    CASE ELSE : fl = 0
    END SELECT

    IF fl = 0 THEN
      SELECT CASE AS CONST T[i]
      CASE ASC(!"\n")
        fl = LEN(r) : IF fl THEN fl -= 1 : IF r[fl] = ASC("\") THEN r[fl] = ASC("_")
        r &= CHR(T[i]) : fl = 2
      CASE ASC("0") : fl = 6
      CASE ASC("1") TO ASC("9") : r &= CHR(T[i]) : fl = 3
      CASE ASC(!"\t"), ASC(" ") : fl = 32
      CASE ASC("^") : r &= "XOR" : fl = 32
      CASE ASC("~") : r &= "NOT" : fl = 32
      CASE ASC("%") : r &= "MOD" : fl = 32
      CASE ASC("!") : fl = T[i]
      CASE ASC(">") : fl = T[i]
      CASE ASC("<") : fl = T[i]
      CASE ASC("|") : fl = T[i]
      CASE ASC("&") : fl = T[i]
      CASE ASC("=") : fl = T[i]
      CASE ELSE : r &= CHR(T[i])
      END SELECT
    END IF
  NEXT : IF fl > 5 THEN r &= CHR(IIF(fl = 6, ASC("0"), fl))
  fl = INSTR(r, "defined")
  WHILE fl : MID(r, fl) = "DEFINED" : fl = INSTR(fl + 7, r, "defined") : WEND
  RETURN r
END FUNCTION

' translates 'x' into ASC("x"), places ! before "
' wandelt 'x' in ASC("x"), ergaenzt ! vor "
SUB H_2_Bi.genQuoteNLogic(BYREF T AS STRING, BYVAL Aa AS INTEGER, _
                          BYREF Lt AS INTEGER, BYVAL Mo AS INTEGER = 0)
  DIM AS STRING y, z, r = T
  DIM AS UINTEGER e = Aa
  T = LEFT(T, Aa)
  FOR i AS INTEGER = Aa TO Lt
    IF CHAR_TYP(r[i]) = 3 THEN
      T &= genLogic(MID(r, e + 1, i - e), Mo)
      IF Op->T.QU THEN
        y = "!""" : z = """"
        IF r[i] = ASC("'") THEN y = "ASC(" & y : z &= ")"
      ELSE
        y = CHR(r[i]) : z = y
      END IF
      e = findBlockEnd(r, i, Lt) : IF e < 0 THEN e = i + 1 : EXIT FOR
      T &= y & MID(r, i + 2, e - i - 1) & z
      e += 1 : i = e
    END IF
  NEXT : T &= genLogic(MID(r, e + 1), Mo) : Lt = LEN(T) - 1
END SUB

' checks In->Tex for ( ? : )
' prueft In->Tex auf C-Bloecke IIF, ersetzt sie durch FB-Befehle
SUB H_2_Bi.genIif(BYVAL Aa AS INTEGER, BYVAL Lt AS INTEGER)
  VAR i = Lt + 1
  DIM AS UBYTE af
  WITH *In
    DO
      DO
        i -= 1 : IF i < Aa THEN EXIT SUB
        SELECT CASE AS CONST CHAR_TYP(.Tex[i])
        CASE 3 : checkAf(af, .Tex, i) '              ASC("'"), ASC("""")
        CASE 6 : IF af = 0 THEN EXIT DO '                       ASC(":")
        END SELECT
      LOOP
      VAR p = findBlockEnd(.Tex, i - 1, Aa, ASC("?")) : IF p < 0 THEN EXIT SUB
      .Tex[i] = ASC(",")
      .Tex[p] = ASC(",")
      p = findBlockEnd(.Tex, i - 1, Aa, ASC("("))
      IF p < 0 THEN p = findBlockEnd(.Tex, i - 1, Aa, ASC("["))
      IF p < 0 THEN .Tex = LEFT(.Tex, Aa) & "IIF(" & MID(.Tex, Aa + 1) & ")" : EXIT SUB
      .Tex = LEFT(.Tex, p) & "IIF" & MID(.Tex, p + 1)
      i += 3
    LOOP
  END WITH
END SUB

' checks if a define line is unsave
' prueft ob eine define Zeile unsicher ist
FUNCTION H_2_Bi.UnsaveDefine() AS INTEGER
  DIM AS UBYTE af
  FOR i AS INTEGER = 0 TO LEN(In->Tex) - 1
    SELECT CASE AS CONST CHAR_TYP(In->Tex[i])
    CASE 3 : checkAf(af, In->Tex, i)
    CASE 7 : IF af = 0 THEN Er->E.USDE = 1 : RETURN -1
    END SELECT
  NEXT : RETURN 0
END FUNCTION

' reads one (or multiple) line starting with '#'
' liest eine oder mehrere Zeilen fuer den Praeprozessor
FUNCTION H_2_Bi.PreCo() AS STRING
  In->readLine(1) : Kompri(In->Tex, -1)
  VAR a = 0
  SELECT CASE nextWord(In->Tex, a)
  CASE "include" : IF Op->T.PI = 0 THEN RETURN ""
    VAR l = LEN(In->Tex) - 1 : Op->I.RAUS = Op->I.PI
    a = findBlockEnd(In->Tex, l, 0) : IF a < 0 THEN RETURN genKom("#" & In->Tex)
    IF Act(MID(In->Tex, a + 2, l - a - 1)) THEN RETURN Tex
    RETURN ""
  CASE "ifdef" : IF Op->T.PX = 0 THEN RETURN ""
    Op->I.RAUS = Op->I.PX
    IF Op->O.MI THEN IfNa &= CHR(1) & TRIM(MID(In->Tex, a + 2), TRIMM)
    MID(In->Tex, a - 4, 5) = "IFDEF"
  CASE "ifndef" : IF Op->T.PX = 0 THEN RETURN ""
    Op->I.RAUS = Op->I.PX
    IF Op->O.MI THEN IfNa &= CHR(1) & TRIM(MID(In->Tex, a + 2), TRIMM)
    MID(In->Tex, a - 5, 6) = "IFNDEF"
  CASE "if" : IF Op->T.PX = 0 THEN RETURN ""
    Op->I.RAUS = Op->I.PX : genQuoteNLogic(In->Tex, a, LEN(In->Tex) - 1)
    IF Op->O.MI THEN
      VAR t = CHR(1) & LTRIM(MID(In->Tex, a + 2), TRIMM)
      IF LEN(t) > 16 THEN IfNa &= LEFT(t, 16) & "..." ELSE IfNa &= t
    END IF : MID(In->Tex, a - 1, 2) = "IF"
  CASE "elif" : IF Op->T.PX = 0 THEN RETURN ""
    Op->I.RAUS = Op->I.PX : genQuoteNLogic(In->Tex, a, LEN(In->Tex) - 1)
    In->Tex = "ELSEIF" & MID(In->Tex, a + 1)
  CASE "else" : IF Op->T.PX = 0 THEN RETURN ""
    Op->I.RAUS = Op->I.PX  : MID(In->Tex, a - 3, 4) = "ELSE"
    In->Tex &= genIfComment(1)
  CASE "endif" : IF Op->T.PX = 0 THEN RETURN ""
    Op->I.RAUS = Op->I.PX  : MID(In->Tex, a - 4, 5) = "ENDIF"
    In->Tex &= genIfComment()
  CASE "error" : IF Op->T.PE = 0 THEN RETURN ""
    Op->I.RAUS = Op->I.PE : MID(In->Tex, a - 4, 5) = "ERROR"
  CASE "undef" : IF Op->T.PU = 0 THEN RETURN ""
    Op->I.RAUS = Op->I.PU  : MID(In->Tex, a - 4, 5) = "UNDEF"
  CASE "define" : IF Op->T.PD = 0 THEN RETURN ""
    Op->I.RAUS = Op->I.PD  : MID(In->Tex, a - 5, 6) = "DEFINE"
    VAR lt = LEN(In->Tex) - 1
    IF a >= lt THEN RETURN genKom("#" & In->Tex & " ' ??? no macro")
    IF genCast(a, lt) THEN Op->I.RAUS OR= Op->I.CA
    genQuoteNLogic(In->Tex, a, lt, 1)
    IF Op->T.II THEN genIif(a, lt)
    IF UnsaveDefine() THEN IF Op->O.UD THEN RETURN genKom("#" & In->Tex)
  CASE ELSE : RETURN genKom("#" & In->Tex)
  END SELECT : RETURN "#" & In->Tex
END FUNCTION

' generating FB lines for ENUM block
' erzeugt FB-Zeilen eines ENUM-Blockes
FUNCTION H_2_Bi.BlockENUM() AS STRING
  VAR r = "" : Typ = ""
  WHILE In->weGo()
    read2(",}#", 1)
    SELECT CASE AS CONST In->LaCh()
    CASE ASC("#")
      IF Op->I.BLCO THEN r &= In->readCCom(Op->Art_Co)
      r &= NL & PreCo() & Er->show()
    CASE ASC(","), ASC("}")
      IF LEN(In->Tex) THEN
        Nam = In->Tex : ModI = &b0001010 : checkNaTy()
        IF Op->I.BLCO THEN r &= In->readCCom(Op->Art_Co)
        r &= NL & Tabz
        IF Er->FLE ANDALSO Op->I.ER THEN r &= genKom(Nam) & NL & Tabz
        r &= Nam & Er->show()
      END IF : IF In->LaCh() = ASC("}") THEN EXIT WHILE
    END SELECT
  WEND : RETURN r
END FUNCTION

' generates FB lines for blocks
' erzeugt FB-Zeilen fuer einen Block (TYPE/UNION)
FUNCTION H_2_Bi.BlockTyUn() AS STRING
  VAR r = ""
  WHILE In->weGo()
    read2(";={}#", 1)
    SELECT CASE AS CONST In->LaCh()
    CASE ASC("#")
      IF Op->I.BLCO THEN r &= In->readCCom(Op->Art_Co)
      r &= NL & PreCo() & Er->show()
    CASE ASC(";"), ASC("=")
      IF In->LaCh() = ASC("=") THEN In->Tex &= "=" : read2(";") ' !!! #-PreCo Zeilen
      ModI = &b0000011 : Tex = In->Tex : translate()
      IF Op->I.BLCO THEN r &= In->readCCom(Op->Art_Co)
      IF Er->FLE ANDALSO Op->I.ER THEN r &= NL & genKom(In->Tex)
      r &= NL & genDefLine(Tabz) & Er->show()
    CASE ASC("{")
      IF Op->I.BLCO THEN r &= In->readCCom(Op->Art_Co)
      VAR neu = Block()
      IF LEFT(neu, 3) = "AS " THEN
        r &= NL & Tabz
        BlRp = MKI(LEN(r) + INSTR(neu, "AS ") + 3) & BlRp : r &= neu
      ELSE
        read2(";", 1) : IF LEN(neu) THEN r &= NL & Tabz & neu
      END IF
    CASE ASC("}")
      IF Op->I.BLCO THEN r &= In->readCCom(Op->Art_Co)
      EXIT WHILE
    END SELECT
  WEND : RETURN r
END FUNCTION

' filles names into block
' fuellt die Namen in den Block (TYPE/UNION)
SUB H_2_Bi.insertBlNa(BYREF Na AS STRING)
  VAR i = 0, p = 0, po = 0, x = LEN(BlVo), l = LEN(BlXx) - 4 : IF l < 1 THEN EXIT SUB
  DO
    p = 0
    FOR i = 1 TO l STEP 4
      po = CVI(MID(BlXx, i, 4))
      IF po < x THEN IF po > p THEN p = po
    NEXT : x = p : IF p = 0 THEN EXIT DO
    BlVo = LEFT(BlVo, p - 1) & Na & "_" & MID(BlVo, p)
  LOOP UNTIL 0
END SUB

' remembers the positions where to fill the names (TYPE/UNION)
' speichert die Positionen zum Auffuellen der Namen im Block
SUB H_2_Bi.fillTYXX(BYVAL Lt AS INTEGER)
  VAR l = LEN(BlVo), o = 0, p = LEN(BlRp) - 3 : IF p < 5 THEN BlXx &= MKI(l + Lt) : EXIT SUB
  o = CVI(MID(BlRp, p, 4)) + l
  FOR i AS INTEGER = 1 TO p - 4 STEP 4
    BlXx &= MKI(o + CVI(MID(BlRp, i, 4)))
  NEXT : BlXx &= MKI(l + Lt)
END SUB

' checks names of blocks
' prueft Namen eines Blockes, liefert ggf auch TYPE-Zeile in Nam
SUB H_2_Bi.BlockName(BYVAL Mo AS INTEGER)
  IF LEN(Typ) THEN '                                block Typ {...} ...;
    IF LCASE(Typ) = LCASE(Nam) THEN Nam = ""
    IF checkFbKw(Typ, Op->T.KW) THEN Typ &= TYKENN
    IF LEN(Nam) = 0 THEN EXIT SUB
  ELSEIF LEN(Nam) = 0 THEN '                                block {...};
    IF Mo THEN IF Op->T.UV THEN Typ = TYKENN
    EXIT SUB
  END IF '    block Typ {...}; | block {...} Nam; | block Typ {...} Nam;
  ModI = IIF(Mo, &b0001011, &b0001001) : checkNaTy()
  DIM AS INTEGER p
  SELECT CASE AS CONST ModO
  CASE 0 : IF LEN(Typ) = 0 THEN Typ = Nam : Nam = "" : EXIT SUB
  CASE 2 : IF LEN(Typ) = 0 THEN Typ = nextWord(Nam) & TYKENN
  CASE ELSE
    IF ModO = 3 THEN STRreplace(Nam, !"\t", ", ")
    IF LEN(Typ) = 0 THEN
      p = INSTR(Nam, ANY !"\t,") : Typ = LEFT(Nam, p - 1) : Nam = MID(Nam, p + 2)
    ELSE
      p = INSTR(UCASE(Nam), UCASE(Typ))
      IF p THEN
        Nam = LEFT(Nam, p - 1) & MID(Nam, p + LEN(Typ))
        Kompri(Nam, 1) : STRreplace(Nam, ",,", ",")
      END IF
    END IF
  END SELECT : Nam = "AS " & Typ & " " & Nam
END SUB

' generates one (or more) block(s)
' erzeugt einen (bei Verschachtelung mehrere) Blo(e)ck(e)
FUNCTION H_2_Bi.Block(BYVAL A AS INTEGER = 0) AS STRING
  DIM AS STRING neu, blna, ei = Einr, rp = BlRp, art
  VAR fl = 0, i = A
  Typ = nextWord(In->Tex, i)
  SELECT CASE Typ
  CASE "enum"   : art = "ENUM"  : fl =  0
  CASE "union"  : art = "UNION" : fl = -1
  CASE "struct" : art = "TYPE"  : fl = -1
  CASE ELSE
    SELECT CASE Typ
    CASE "extern", "namespace" : Nam = "line"
    CASE ELSE : Nam = "block"
      WHILE In->LaCh() <> ASC("}") : In->readTo("}") : WEND   ' : In->readTo(!";")
    END SELECT : Op->I.RAUS = Op->I.UT : IF Op->O.MB = 0 THEN RETURN ""
    IF LEN(Typ) THEN BlTy &= CHR(1) & Typ : RETURN "' removed """ & Typ & """ " & Nam
    VAR p = INSTRREV(BlTy, CHR(1))
    IF p THEN Typ = MID(BlTy, p + 1) : BlTy = LEFT(BlTy, p - 1) ELSE Typ = "???"
    RETURN "' } form removed """ & Typ & """ " & Nam
  END SELECT : blna = nextWord(In->Tex, i)
  IF BlNr = 0 THEN BlVo = "" : BlXx = "" : Einr = Tabz : In->newBlock()
  BlRp = "" : BlNr += 1
  IF fl THEN neu = BlockTyUn() ELSE neu = BlockENUM()
  BlNr -= 1
  read2(";", 1) : Nam = In->Tex : Typ = blna
  BlockName(BlNr - fl) : Einr = ei
  IF LEN(Typ) THEN
    IF Op->T.UT THEN IF STACK_FIN(Ou->TyNa, Typ) THEN Typ &= TYKENN
  END IF
  IF LEN(BlRp) THEN BlRp += MKI(LEN(art) + LEN(Typ) + 1)
  fillTYXX(LEN(art) + 2) : BlRp = rp
  IF LEN(neu) THEN BlVo &= art & " " & Typ & neu & NL & "END " & art
  IF BlNr THEN
    BlVo &= NL & NL : IF LEN(Nam) THEN RETURN Nam
    RETURN "AS " & Typ & " " & Typ
  ELSEIF LEN(Nam) THEN Nam = NL & NL & "TYPE " & Nam
  ELSEIF LEN(neu) = 0 THEN
    IF LEN(Typ) THEN
      Op->I.RAUS = Op->I.TY : IF Op->T.TY = 0 THEN RETURN ""
      RETURN "TYPE " & Typ & " AS ANY PTR"
    END IF
  END IF
  SELECT CASE AS CONST art[0]
  CASE ASC("T") : Op->I.RAUS = Op->I.BT : IF Op->T.BT = 0 THEN RETURN ""
  CASE ASC("E") : Op->I.RAUS = Op->I.BE : IF Op->T.BE = 0 THEN RETURN ""
  CASE ASC("U") : Op->I.RAUS = Op->I.BU : IF Op->T.BU = 0 THEN RETURN ""
  END SELECT : insertBlNa(Typ) : Ou->LaWo = CHR(1) : RETURN BlVo & Nam
END FUNCTION

' checkes file by name (done, exists)
' pueft, ob Datei bereits bearbeitet wurde
FUNCTION H_2_Bi.checkFileNam(BYREF F AS STRING) AS STRING
  VAR r = F, p = Co->Head.rep(r)
  IF p <> SADD(r) THEN
    RETURN "#INCLUDE ONCE """ & *p & """ '" & KEY_HEADERS & ": " & F
  END IF : IF FILEEXISTS(F) THEN RETURN ""
  VAR a = 6, e = INSTR(a, Co->Fold, CHR(1))
  WHILE e > a '                                     search __FOLDERS__
    F = MID(Co->Fold, a, e - a) & r
    IF FILEEXISTS(F) THEN
      IF STACK_FIN(Ou->Fok, F) THEN RETURN "' file allready done: " & F
      STACK_ADD(Ou->Fok, F) : RETURN ""
    END IF : a = e + 1 : e = INSTR(a, Co->Fold, CHR(1))
  WEND
  IF STACK_FIN(Ou->Fko, r) THEN RETURN "' file allready missed: " & r
  STACK_ADD(Ou->Fko, r) : RETURN "' file not found: " & r
END FUNCTION
